package game;

import pokerenum.PokerLevelEnum;
import result.StrategyResult;
import strategy.impl.ColorStrategy;
import strategy.impl.Strategy;

import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class Judger {

    public static void judge(List<Strategy> strategies, Gamer a, Gamer b) {
        Judger judger = new Judger();
        PreJudgeResult aresult = judger.compareStrategy(strategies, a);
        PreJudgeResult bresult = judger.compareStrategy(strategies, b);
        int scoreA = aresult.getScore();
        int scoreB = bresult.getScore();
        String apoker = showPoker(a);
        String bpoker = showPoker(b);
        PokerLevelEnum aprase = PokerLevelEnum.prase(scoreA);
        PokerLevelEnum bprase = PokerLevelEnum.prase(scoreB);
        System.out.println("a poker: " + apoker + ",b poker: " + bpoker);
        System.out.println("a poker level:" + aprase.getDesc() + ",b poker level: " + bprase.getDesc());
        if (scoreA == scoreB) {
            String orderStrA;
            String orderStrB;
            orderStrB = Strategy.getOrderStr(b);
            orderStrA = Strategy.getOrderStr(a);
            if (orderStrA.compareTo(orderStrB) > 0) {
                System.out.println("A victory");
            } else if (orderStrA.compareTo(orderStrB) == 0) {
                System.out.println("A tie B");
            } else {
                System.out.println("B victory");
            }
        } else {
            if (scoreA > scoreB) {
                System.out.println("A victory");
            } else {
                System.out.println("B victory");
            }
        }
    }

    public static String getOrderStrAfterRemoveUsefulPoker(Gamer gamer, Poker mostUserFulPoker) {
        List<Poker> pokers = gamer.getPokers();
        StringBuffer orderStr = new StringBuffer();
        Collections.sort(pokers);
        Iterator<Poker> iterator = pokers.iterator();
        while (iterator.hasNext()) {
            Poker next = iterator.next();
            if (next.getValueEnum().getValue() == mostUserFulPoker.getValueEnum().getValue()) {
                iterator.remove();
            }
        }
        for (Poker poker : pokers) {
            orderStr.append(poker.getValueEnum().getOrderValue());
        }
        return orderStr.toString();
    }

    public static String showPoker(Gamer gamer) {
        List<Poker> pokers = gamer.getPokers();
        StringBuffer pokerStr = new StringBuffer();
        Collections.sort(pokers);
        for (Poker poker : pokers) {
            pokerStr.append(poker.getColorEnum().getDesc());
            pokerStr.append(poker.getValueEnum().getDesc());
        }
        return pokerStr.toString();
    }

    public PreJudgeResult compareStrategy(List<Strategy> strategies, Gamer agamer) {
        PreJudgeResult result = new PreJudgeResult();
        int score = 0;
        Poker aMaxUserfulPoker = null;
        for (Strategy strategy : strategies) {
            StrategyResult mactch = strategy.mactch(agamer);
            Poker maxUsefulPoker = mactch.getMaxUsefulPoker();
            if (maxUsefulPoker != null) {
                aMaxUserfulPoker = maxUsefulPoker;
            }
            if (mactch.getPokerLevelEnum().getScore() != PokerLevelEnum.HIGHCARD.getScore()) {
                score += mactch.getPokerLevelEnum().getScore();
            }
        }
        result.setScore(score);
        result.setMaxUseFulPoker(aMaxUserfulPoker);
        return result;
    }


    public class PreJudgeResult {
        private int score;
        private Poker maxUseFulPoker;

        public int getScore() {
            return score;
        }

        public void setScore(int score) {
            this.score = score;
        }

        public Poker getMaxUseFulPoker() {
            return maxUseFulPoker;
        }

        public void setMaxUseFulPoker(Poker maxUseFulPoker) {
            this.maxUseFulPoker = maxUseFulPoker;
        }
    }

}
