package strategy.impl;

import game.Gamer;
import game.Poker;
import pokerenum.PokerLevelEnum;
import pokerenum.PokerValueEnum;
import result.StrategyResult;

import java.util.HashSet;
import java.util.List;

public class ColorStrategy extends Strategy {
    private static ColorStrategy strategy = null;

    private ColorStrategy() {
    }

    public static ColorStrategy getStrategy() {
        if (strategy == null) {
            strategy = new ColorStrategy();
        }
        return strategy;
    }

    @Override
    public StrategyResult mactch(Gamer gamer) {
        List<Poker> pokers = gamer.getPokers();
        HashSet<String> color = new HashSet<String>();
        Poker maxPoker = null;
        for (Poker poker : pokers) {
            color.add(poker.getColorEnum().getDesc());
            if (maxPoker == null) {
                maxPoker = poker;
            } else if (poker.getValueEnum().getValue() > maxPoker.getValueEnum().getValue()) {
                maxPoker = poker;
            }
        }
        StrategyResult result = new StrategyResult();
        result.setPokerLevelEnum(PokerLevelEnum.DEFAULT);
        result.setMatched(false);
        if (color.size() == 1) {
            result.setMatched(true);
            result.setPokerLevelEnum(PokerLevelEnum.FLUSH);
            result.setMaxUsefulPoker(maxPoker);
        }
        return result;
    }
}
