package strategy.impl;

import game.Gamer;
import game.Poker;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import result.StrategyResult;

import java.util.*;

public abstract class Strategy {

    public abstract StrategyResult mactch(Gamer gamer);

    public String orderStr;


    public static String getOrderStr(Gamer gamer) {
        List<Poker> pokers = gamer.getPokers();
        Collections.sort(pokers);
        List<Character> pokerOrderValue = new LinkedList<Character>();
        MultiValueMap<Character, Character> pokerOrderValueMap = new LinkedMultiValueMap<Character, Character>();
        for (Poker poker : pokers) {
            pokerOrderValue.add(poker.getValueEnum().getOrderValue());
            pokerOrderValueMap.add(poker.getValueEnum().getOrderValue(), poker.getValueEnum().getOrderValue());
        }
        List<Character> result = new ArrayList<Character>(pokerOrderValueMap.keySet());
        Collections.sort(result, new Comparator<Character>() {
            public int compare(Character o1, Character o2) {
                if (o1 < o2) {
                    return 1;
                } else if (o1 == o2) {
                    return 0;
                } else {
                    return -1;
                }
            }
        });
        List<Character> orderCharacterList = new LinkedList<Character>();
        int loopSize = 0;
        if (pokerOrderValueMap.size() != 5) {
            for (Character orderValue : result) {
                List<Character> characters = pokerOrderValueMap.get(orderValue);
                int size = characters.size();
                if (size >= 2) {
                    for (Character character : characters) {
                        orderCharacterList.add(loopSize, character);
                    }
                    loopSize += size;
                } else {
                    orderCharacterList.add(characters.get(0));
                }
            }
        } else {
            for (Character character : pokerOrderValue) {
                orderCharacterList.add(character);
            }
        }
        StringBuffer orderStr = new StringBuffer();
        for (Character character : orderCharacterList) {
            orderStr.append(character);
        }
        return orderStr.toString();
    }
}
